/*
 * The contents of this file are subject to the terms 
 * of the Common Development and Distribution License 
 * (the License).  You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the license at 
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing 
 * permissions and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL 
 * Header Notice in each file and include the License file 
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.  
 * If applicable, add the following below the CDDL Header, 
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information: 
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved.
 */
 
/**
 *	This generated bean class SipContainer matches the DTD element sip-container
 *
 */

package com.sun.enterprise.config.serverbeans;

import org.w3c.dom.*;
import org.netbeans.modules.schema2beans.*;
import java.beans.*;
import java.util.*;
import java.io.Serializable;
import com.sun.enterprise.config.ConfigBean;
import com.sun.enterprise.config.ConfigException;
import com.sun.enterprise.config.StaleWriteConfigException;
import com.sun.enterprise.util.i18n.StringManager;

// BEGIN_NOI18N

public class SipContainer extends ConfigBean implements Serializable
{

	static Vector comparators = new Vector();
	private static final org.netbeans.modules.schema2beans.Version runtimeVersion = new org.netbeans.modules.schema2beans.Version(4, 2, 0);

	static public final String SESSION_CONFIG = "SessionConfig";
	static public final String STACK_CONFIG = "StackConfig";
	static public final String ELEMENT_PROPERTY = "ElementProperty";

	public SipContainer() {
		this(Common.USE_DEFAULT_VALUES);
	}

	public SipContainer(int options)
	{
		super(comparators, runtimeVersion);
		// Properties (see root bean comments for the bean graph)
		initPropertyTables(3);
		this.createProperty("session-config", SESSION_CONFIG, 
			Common.TYPE_0_1 | Common.TYPE_BEAN | Common.TYPE_KEY, 
			SessionConfig.class);
		this.createProperty("stack-config", STACK_CONFIG, 
			Common.TYPE_0_1 | Common.TYPE_BEAN | Common.TYPE_KEY, 
			StackConfig.class);
		this.createAttribute(STACK_CONFIG, "layer-order", "LayerOrder", 
						AttrProp.CDATA | AttrProp.REQUIRED,
						null, null);
		this.createProperty("property", ELEMENT_PROPERTY, 
			Common.TYPE_0_N | Common.TYPE_BEAN | Common.TYPE_KEY, 
			ElementProperty.class);
		this.createAttribute(ELEMENT_PROPERTY, "name", "Name", 
						AttrProp.CDATA | AttrProp.REQUIRED,
						null, null);
		this.createAttribute(ELEMENT_PROPERTY, "value", "Value", 
						AttrProp.CDATA | AttrProp.REQUIRED,
						null, null);
		this.initialize(options);
	}

	// Setting the default values of the properties
	void initialize(int options) {

	}

	// This attribute is optional
	public void setSessionConfig(SessionConfig value) {
		this.setValue(SESSION_CONFIG, value);
	}

	// Get Method
	public SessionConfig getSessionConfig() {
		return (SessionConfig)this.getValue(SESSION_CONFIG);
	}

	// This attribute is optional
	public void setStackConfig(StackConfig value) {
		this.setValue(STACK_CONFIG, value);
	}

	// Get Method
	public StackConfig getStackConfig() {
		return (StackConfig)this.getValue(STACK_CONFIG);
	}

	// Get Method
	public ElementProperty getElementProperty(int index) {
		return (ElementProperty)this.getValue(ELEMENT_PROPERTY, index);
	}

	// This attribute is an array, possibly empty
	public void setElementProperty(ElementProperty[] value) {
		this.setValue(ELEMENT_PROPERTY, value);
	}

	// Getter Method
	public ElementProperty[] getElementProperty() {
		return (ElementProperty[])this.getValues(ELEMENT_PROPERTY);
	}

	// Return the number of properties
	public int sizeElementProperty() {
		return this.size(ELEMENT_PROPERTY);
	}

	// Add a new element returning its index in the list
	public int addElementProperty(ElementProperty value)
			throws ConfigException{
		return addElementProperty(value, true);
	}

	// Add a new element returning its index in the list with a boolean flag
	public int addElementProperty(ElementProperty value, boolean overwrite)
			throws ConfigException{
		ElementProperty old = getElementPropertyByName(value.getName());
		if(old != null) {
			throw new ConfigException(StringManager.getManager(SipContainer.class).getString("cannotAddDuplicate",  "ElementProperty"));
		}
		return this.addValue(ELEMENT_PROPERTY, value, overwrite);
	}

	//
	// Remove an element using its reference
	// Returns the index the element had in the list
	//
	public int removeElementProperty(ElementProperty value){
		return this.removeValue(ELEMENT_PROPERTY, value);
	}

	//
	// Remove an element using its reference
	// Returns the index the element had in the list
	// with boolean overwrite
	//
	public int removeElementProperty(ElementProperty value, boolean overwrite)
			throws StaleWriteConfigException{
		return this.removeValue(ELEMENT_PROPERTY, value, overwrite);
	}

	public ElementProperty getElementPropertyByName(String id) {
	 if (null != id) { id = id.trim(); }
	ElementProperty[] o = getElementProperty();
	 if (o == null) return null;

	 for (int i=0; i < o.length; i++) {
	     if(o[i].getAttributeValue(Common.convertName(ServerTags.NAME)).equals(id)) {
	         return o[i];
	     }
	 }

		return null;
		
	}
	/**
	* Getter for ExternalAddress of the Element sip-container
	* @return  the ExternalAddress of the Element sip-container
	*/
	public String getExternalAddress() {
			return getAttributeValue(ServerTags.EXTERNAL_ADDRESS);
	}
	/**
	* Modify  the ExternalAddress of the Element sip-container
	* @param v the new value
	* @throws StaleWriteConfigException if overwrite is false and file changed on disk
	*/
	public void setExternalAddress(String v, boolean overwrite) throws StaleWriteConfigException {
		setAttributeValue(ServerTags.EXTERNAL_ADDRESS, v, overwrite);
	}
	/**
	* Modify  the ExternalAddress of the Element sip-container
	* @param v the new value
	*/
	public void setExternalAddress(String v) {
		setAttributeValue(ServerTags.EXTERNAL_ADDRESS, v);
	}
	/**
	* Getter for ExternalSipPort of the Element sip-container
	* @return  the ExternalSipPort of the Element sip-container
	*/
	public String getExternalSipPort() {
			return getAttributeValue(ServerTags.EXTERNAL_SIP_PORT);
	}
	/**
	* Modify  the ExternalSipPort of the Element sip-container
	* @param v the new value
	* @throws StaleWriteConfigException if overwrite is false and file changed on disk
	*/
	public void setExternalSipPort(String v, boolean overwrite) throws StaleWriteConfigException {
		setAttributeValue(ServerTags.EXTERNAL_SIP_PORT, v, overwrite);
	}
	/**
	* Modify  the ExternalSipPort of the Element sip-container
	* @param v the new value
	*/
	public void setExternalSipPort(String v) {
		setAttributeValue(ServerTags.EXTERNAL_SIP_PORT, v);
	}
	/**
	* Getter for ExternalSipsPort of the Element sip-container
	* @return  the ExternalSipsPort of the Element sip-container
	*/
	public String getExternalSipsPort() {
			return getAttributeValue(ServerTags.EXTERNAL_SIPS_PORT);
	}
	/**
	* Modify  the ExternalSipsPort of the Element sip-container
	* @param v the new value
	* @throws StaleWriteConfigException if overwrite is false and file changed on disk
	*/
	public void setExternalSipsPort(String v, boolean overwrite) throws StaleWriteConfigException {
		setAttributeValue(ServerTags.EXTERNAL_SIPS_PORT, v, overwrite);
	}
	/**
	* Modify  the ExternalSipsPort of the Element sip-container
	* @param v the new value
	*/
	public void setExternalSipsPort(String v) {
		setAttributeValue(ServerTags.EXTERNAL_SIPS_PORT, v);
	}
	/**
	 * Create a new bean using it's default constructor.
	 * This does not add it to any bean graph.
	 */
	public SessionConfig newSessionConfig() {
		return new SessionConfig();
	}

	/**
	 * Create a new bean using it's default constructor.
	 * This does not add it to any bean graph.
	 */
	public StackConfig newStackConfig() {
		return new StackConfig();
	}

	/**
	 * Create a new bean using it's default constructor.
	 * This does not add it to any bean graph.
	 */
	public ElementProperty newElementProperty() {
		return new ElementProperty();
	}

	/**
	* get the xpath representation for this element
	* returns something like abc[@name='value'] or abc
	* depending on the type of the bean
	*/
	protected String getRelativeXPath() {
	    String ret = null;
	    ret = "sip-container";
	    return (null != ret ? ret.trim() : null);
	}

	/*
	* generic method to get default value from dtd
	*/
	public static String getDefaultAttributeValue(String attr) {
		if(attr == null) return null;
		attr = attr.trim();
	return null;
	}
	//
	public static void addComparator(org.netbeans.modules.schema2beans.BeanComparator c) {
		comparators.add(c);
	}

	//
	public static void removeComparator(org.netbeans.modules.schema2beans.BeanComparator c) {
		comparators.remove(c);
	}
	public void validate() throws org.netbeans.modules.schema2beans.ValidateException {
	}

	// Dump the content of this bean returning it as a String
	public void dump(StringBuffer str, String indent){
		String s;
		Object o;
		org.netbeans.modules.schema2beans.BaseBean n;
		str.append(indent);
		str.append("SessionConfig");	// NOI18N
		n = (org.netbeans.modules.schema2beans.BaseBean) this.getSessionConfig();
		if (n != null)
			n.dump(str, indent + "\t");	// NOI18N
		else
			str.append(indent+"\tnull");	// NOI18N
		this.dumpAttributes(SESSION_CONFIG, 0, str, indent);

		str.append(indent);
		str.append("StackConfig");	// NOI18N
		n = (org.netbeans.modules.schema2beans.BaseBean) this.getStackConfig();
		if (n != null)
			n.dump(str, indent + "\t");	// NOI18N
		else
			str.append(indent+"\tnull");	// NOI18N
		this.dumpAttributes(STACK_CONFIG, 0, str, indent);

		str.append(indent);
		str.append("ElementProperty["+this.sizeElementProperty()+"]");	// NOI18N
		for(int i=0; i<this.sizeElementProperty(); i++)
		{
			str.append(indent+"\t");
			str.append("#"+i+":");
			n = (org.netbeans.modules.schema2beans.BaseBean) this.getElementProperty(i);
			if (n != null)
				n.dump(str, indent + "\t");	// NOI18N
			else
				str.append(indent+"\tnull");	// NOI18N
			this.dumpAttributes(ELEMENT_PROPERTY, i, str, indent);
		}

	}
	public String dumpBeanNode(){
		StringBuffer str = new StringBuffer();
		str.append("SipContainer\n");	// NOI18N
		this.dump(str, "\n  ");	// NOI18N
		return str.toString();
	}}

// END_NOI18N

