/*
* The contents of this file are subject to the terms
* of the Common Development and Distribution License
* (the License).  You may not use this file except in
* compliance with the License.
*
* You can obtain a copy of the license at
* https://glassfish.dev.java.net/public/CDDLv1.0.html or
* glassfish/bootstrap/legal/CDDLv1.0.txt.
* See the License for the specific language governing
* permissions and limitations under the License.
*
* When distributing Covered Code, include this CDDL
* Header Notice in each file and include the License file
* at glassfish/bootstrap/legal/CDDLv1.0.txt.
* If applicable, add the following below the CDDL Header,
* with the fields enclosed by brackets [] replaced by
* you own identifying information:
* "Portions Copyrighted [year] [name of copyright owner]"
*
* Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
* Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
*/
package com.ericsson.ssa.config.annotations;

/**
 * Indicates how the Configuration Item is to be used. 
 * 
 * @author elnelbo
 */
public enum UsagePolicy {
    /** FAIL when item is not provided in the Configuration. The Configuration item is treated as mandatory.*/
    FAIL,
    /** WARN when item is not provided in the Configuration. Logs a warning. The Configuration item is treated as expected.*/
    WARN,
    /** IGNORE when item is not provided in the Configuration. Igonores. The Configuration item is treated as optional.*/
    IGNORE,    
    /** Use default when item is not provided in the Configuration. The Configuration item is treated as optional.*/    
    DEFAULT
}
