/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License).  You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
 */
package com.ericsson.ssa.dd;

import java.io.Serializable;


public class EjbReference implements Serializable {
    private static final long serialVersionUID = 3258408426458722609L;
    private String name;
    private String description;
    private String type;
    private String home;
    private String remote;
    private String ejbLink;

    /**
     * @return
     */
    public String getName() {
        return name;
    }

    /**
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return
     */
    public String getDescription() {
        return description;
    }

    /**
     * @param description
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * @return
     */
    public String getType() {
        return type;
    }

    /**
     * @param type
     */
    public void setType(String type) {
        if (!EjbReferenceType.contains(type)) {
            throw new RuntimeException("Ejb reference type must be of " +
                EjbReferenceType.printNames());
        }

        this.type = type;
    }

    /**
     * @return
     */
    public String getHome() {
        return home;
    }

    /**
     * @param home
     */
    public void setHome(String home) {
        this.home = home;
    }

    /**
     * @return
     */
    public String getRemote() {
        return remote;
    }

    /**
     * @param remote
     */
    public void setRemote(String remote) {
        this.remote = remote;
    }

    /**
     * @return
     */
    public String getEjbLink() {
        return ejbLink;
    }

    /**
     * @param ejbLink
     */
    public void setEjbLink(String ejbLink) {
        this.ejbLink = ejbLink;
    }
}
