/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License).  You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
 */
package com.ericsson.ssa.dd;

public class EnvironmentEntryType extends Enum {
    public static final EnvironmentEntryType BOOLEAN = new EnvironmentEntryType(Boolean.class.getName());
    public static final EnvironmentEntryType BYTE = new EnvironmentEntryType(Byte.class.getName());
    public static final EnvironmentEntryType CHARACTER = new EnvironmentEntryType(Character.class.getName());
    public static final EnvironmentEntryType STRING = new EnvironmentEntryType(String.class.getName());
    public static final EnvironmentEntryType SHORT = new EnvironmentEntryType(Short.class.getName());
    public static final EnvironmentEntryType INTEGER = new EnvironmentEntryType(Integer.class.getName());
    public static final EnvironmentEntryType LONG = new EnvironmentEntryType(Long.class.getName());
    public static final EnvironmentEntryType FLOAT = new EnvironmentEntryType(Float.class.getName());
    public static final EnvironmentEntryType DOUBLE = new EnvironmentEntryType(Double.class.getName());

    private EnvironmentEntryType(String name) {
        super(name);
    }

    public static boolean contains(String name) {
        return Enum.contains(EnvironmentEntryType.class, name);
    }

    public static String printNames() {
        return Enum.toString(EnvironmentEntryType.class);
    }
}
