/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License).  You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Copyright (c) Ericsson AB, 2004-2007. All rights reserved.
 */
package com.ericsson.ssa.dd;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collection;


public class ResourceCollection implements Serializable {
    private static final long serialVersionUID = 3257001073033164854L;
    private String name;
    private String description;
    private Collection<String> servletNames;
    private Collection<String> sipMethods;

    /**
     * Default constructor.
     */
    public ResourceCollection() {
    }

    /**
     * @param servletName
     */
    public void addServletName(String servletName) {
        if (servletNames == null) {
            servletNames = new ArrayList<String>();
        }

        servletNames.add(servletName);
    }

    /**
     * @param sipMethod
     */
    public void addSipMethod(String sipMethod) {
        if (sipMethods == null) {
            sipMethods = new ArrayList<String>();
        }

        sipMethods.add(sipMethod);
    }

    /**
     * @return
     */
    public Collection getServletNames() {
        return servletNames;
    }

    /**
     * @return
     */
    public Collection getSipMethods() {
        return sipMethods;
    }

    /**
     * @return
     */
    public String getName() {
        return name;
    }

    /**
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return
     */
    public String getDescription() {
        return description;
    }

    /**
     * @param description
     */
    public void setDescription(String description) {
        this.description = description;
    }
}
